import { Match } from './match';
import { Result } from './result';
export declare type OptionMatcher<T, U> = {
    Some: (value: T) => U;
    None: () => U;
};
export declare const Some: <T>(value: T) => Option<T>;
export declare const None: () => Option<any>;
export declare class Option<T> implements Match {
    protected value: T;
    constructor(value: T);
    readonly isSome: boolean;
    readonly isNone: boolean;
    expect(msg: string): T;
    unwrap(): T;
    unwrapOr(def: T): T;
    unwrapOrElse(cb: () => T): T;
    map<U>(cb: (value: T) => U): Option<U>;
    mapOr<U>(def: U, cb: (value: T) => U): U;
    mapOrElse<U>(def: () => U, cb: (value: T) => U): U;
    match<U>(matcher: OptionMatcher<T, U>): U;
    okOr<E>(err: E): Result<T, E>;
    okOrElse<E>(err: () => E): Result<T, E>;
    and<U>(optb: Option<U>): Option<U>;
    andThen<U>(cb: (value: T) => Option<U>): Option<U>;
    or(optb: Option<T>): Option<T>;
    orElse(cb: () => Option<T>): Option<T>;
}
