"use strict";
var result_1 = require("./result");
exports.Some = function (value) { return new Option(value); };
exports.None = function () { return new Option(null); };
var Option = (function () {
    function Option(value) {
        this.value = value;
    }
    Object.defineProperty(Option.prototype, "isSome", {
        get: function () {
            return !!this.value;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Option.prototype, "isNone", {
        get: function () {
            return !this.value;
        },
        enumerable: true,
        configurable: true
    });
    Option.prototype.expect = function (msg) {
        if (this.isSome) {
            return this.value;
        }
        throw new Error(msg);
    };
    Option.prototype.unwrap = function () {
        if (this.isSome) {
            return this.value;
        }
        throw new Error();
    };
    Option.prototype.unwrapOr = function (def) {
        return this.isSome
            ? this.value
            : def;
    };
    Option.prototype.unwrapOrElse = function (cb) {
        return this.isSome
            ? this.value
            : cb();
    };
    Option.prototype.map = function (cb) {
        return this.isSome
            ? exports.Some(cb(this.value))
            : this;
    };
    Option.prototype.mapOr = function (def, cb) {
        return this.isSome
            ? cb(this.value)
            : def;
    };
    Option.prototype.mapOrElse = function (def, cb) {
        return this.isSome
            ? cb(this.value)
            : def();
    };
    Option.prototype.match = function (matcher) {
        return this.isSome
            ? matcher.Some(this.value)
            : matcher.None();
    };
    Option.prototype.okOr = function (err) {
        return this.isSome
            ? result_1.Ok(this.value)
            : result_1.Err(err);
    };
    Option.prototype.okOrElse = function (err) {
        return this.isSome
            ? result_1.Ok(this.value)
            : result_1.Err(err());
    };
    Option.prototype.and = function (optb) {
        return this.isSome
            ? optb
            : this;
    };
    Option.prototype.andThen = function (cb) {
        return this.isSome
            ? cb(this.value)
            : this;
    };
    Option.prototype.or = function (optb) {
        return this.isSome
            ? this
            : optb;
    };
    Option.prototype.orElse = function (cb) {
        return this.isSome
            ? this
            : cb();
    };
    return Option;
}());
exports.Option = Option;
//# sourceMappingURL=option.js.map