import { Option } from './option';
import { Match } from './match';
export declare type ResultMatcher<T, E, U> = {
    Ok: (value: T) => U;
    Err: (err: E) => U;
};
export declare const Ok: <T>(value: T) => Result<T, any>;
export declare const Err: <E>(error: E) => Result<any, E>;
export declare class Result<T, E> implements Match {
    protected value: T;
    protected error: E;
    constructor(value: T, error: E);
    readonly ok: Option<T>;
    readonly err: Option<E>;
    readonly isOk: boolean;
    readonly isErr: boolean;
    map<U>(cb: (value: T) => U): Result<U, E>;
    mapErr<F>(cb: (error: E) => F): Result<T, F>;
    match<U>(matcher: ResultMatcher<T, E, U>): U;
    and<U>(res: Result<U, E>): Result<U, E>;
    andThen<U>(cb: (value: T) => Result<U, E>): Result<U, E>;
    or<F>(res: Result<T, F>): Result<T, F>;
    orElse<F>(cb: (error: E) => Result<T, F>): Result<T, F>;
    unwrapOr(optb: T): T;
    unwrapOrElse(cb: (error: E) => T): T;
    unwrap(): T;
    unwrapErr(): E;
    expect(msg: string): T;
}
